Index: trunk/zoo-project/zoo-kernel/service_internal_ruby.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_ruby.c	(revision 459)
+++ trunk/zoo-project/zoo-kernel/service_internal_ruby.c	(revision 581)
@@ -1,3 +1,3 @@
-/**
+/*
  * Author : Gérald FENOY
  *
@@ -30,4 +30,17 @@
 #endif
 
+/**
+ * Load a Ruby file then run the function corresponding to the service by
+ * passing the conf, inputs and outputs parameters by value as JavaScript
+ * Objects.
+ *
+ * @param main_conf the conf maps containing the main.cfg settings
+ * @param request the map containing the HTTP request
+ * @param s the service structure
+ * @param real_inputs the maps containing the inputs
+ * @param real_outputs the maps containing the outputs
+ * @return SERVICE_SUCCEEDED or SERVICE_FAILED if the service run, -1 
+ *  if the service failed to load or throw error at runtime.
+ */
 int zoo_ruby_support(maps** main_conf,map* request,service* s,maps **real_inputs,maps **real_outputs){
 #if RUBY_API_VERSION_MAJOR >= 2 || RUBY_API_VERSION_MINOR == 9
@@ -125,4 +138,10 @@
 }
 
+/**
+ * Load a ruby file
+ *
+ * @arg the file to load
+ * @return Qnil
+ */
 VALUE LoadWrap(VALUE arg) {
   const char *filename = reinterpret_cast<const char*>(arg);
@@ -131,4 +150,10 @@
 }
 
+/**
+ * Call a ruby function with parameters
+ *
+ * @arg the callback structure
+ * @return the value returned the called ruby function
+ */
 VALUE FunCallWrap(VALUE rdata) {
   struct my_callback* data = (struct my_callback*) rdata;
@@ -136,4 +161,10 @@
 }
 
+/**
+ * Print the Ruby Stack Trace in an ows:ExceptionReport XML Document
+ *
+ * @param m the conf maps containing the main.cfg settings
+ * @see printExceptionReportResponse
+ */
 void ruby_trace_error(maps* m){
 #if RUBY_VERSION_MINOR == 8
@@ -174,4 +205,10 @@
 }
 
+/**
+ * Convert a maps to a Ruby Hash
+ *
+ * @param t the maps to convert
+ * @return a new Ruby Hash
+ */
 VALUE RubyHash_FromMaps(maps* t){
   VALUE res=rb_hash_new();
@@ -186,4 +223,12 @@
 }
 
+/**
+ * Push the key on the array
+ *
+ * @param key the key to push
+ * @param value not used
+ * @param ary the Array
+ * @return ST_CONTINUE
+ */
 int
 keys_i(VALUE key,VALUE value,VALUE ary)
@@ -194,4 +239,9 @@
 }
 
+/**
+ * Return the size of a Ruby Hash
+ * 
+ * @param hash the input Hash
+ */
 VALUE
 rb_hash_size(VALUE hash)
@@ -200,4 +250,10 @@
 }
 
+/**
+ * Convert a map to a Ruby Hash
+ *
+ * @param t the map to convert
+ * @return a new Ruby Hash
+ */
 VALUE RubyHash_FromMap(map* t){
   VALUE res=rb_hash_new( );
@@ -277,5 +333,10 @@
 }
 
-
+/**
+ * Convert a Ruby Hash to a maps
+ *
+ * @param t the Ruby Hash to convert
+ * @return a new maps
+ */
 maps* mapsFromRubyHash(VALUE t){
   maps* res=NULL;
@@ -309,4 +370,10 @@
 }
 
+/**
+ * Convert a Ruby Hash to a map
+ *
+ * @param t the Ruby Hash to convert
+ * @return a new map
+ */
 map* mapFromRubyHash(VALUE t){
   map* res=NULL;
@@ -354,4 +421,14 @@
 }
 
+/**
+ * Use the ZOO-Services messages translation function from the Ruby
+ * environment (ZOO-API)
+ *
+ * @param argc the number of parameters
+ * @param argv the parameter values given from the Ruby environment
+ * @param obj the Ruby object on which we run the method
+ * @return a new Ruby string containing the translated value
+ * @see _ss
+ */
 VALUE
 RubyTranslate(int argc, VALUE *argv, VALUE obj)
@@ -360,4 +437,14 @@
 }
 
+/**
+ * Update the ongoing status of a running service from the Ruby environment
+ * (ZOO-API)
+ *
+ * @param argc the number of parameters
+ * @param argv the parameter values given from the Ruby environment
+ * @param obj the Ruby object on which we run the method
+ * @return a new Ruby string containing the translated value
+ * @see _updateStatus
+ */
 VALUE
 RubyUpdateStatus(int argc, VALUE *argv, VALUE obj)
@@ -392,5 +479,5 @@
     else
       setMapInMaps(conf,"lenv","status","15");
-    updateStatus(conf);
+    _updateStatus(conf);
   }
   freeMaps(&conf);